<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFailureInformation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFailureInformation
 * @subpackage Arrays
 */
class ArrayOfFailureInformation extends AbstractStructArrayBase
{
    /**
     * The FailureInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\FailureInformation[]
     */
    public $FailureInformation;
    /**
     * Constructor method for ArrayOfFailureInformation
     * @uses ArrayOfFailureInformation::setFailureInformation()
     * @param \patest\StructType\FailureInformation[] $failureInformation
     */
    public function __construct(array $failureInformation = array())
    {
        $this
            ->setFailureInformation($failureInformation);
    }
    /**
     * Get FailureInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\FailureInformation[]|null
     */
    public function getFailureInformation()
    {
        return isset($this->FailureInformation) ? $this->FailureInformation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFailureInformation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFailureInformation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFailureInformationForArrayConstraintsFromSetFailureInformation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFailureInformationFailureInformationItem) {
            // validation for constraint: itemType
            if (!$arrayOfFailureInformationFailureInformationItem instanceof \patest\StructType\FailureInformation) {
                $invalidValues[] = is_object($arrayOfFailureInformationFailureInformationItem) ? get_class($arrayOfFailureInformationFailureInformationItem) : sprintf('%s(%s)', gettype($arrayOfFailureInformationFailureInformationItem), var_export($arrayOfFailureInformationFailureInformationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FailureInformation property can only contain items of type \patest\StructType\FailureInformation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FailureInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\FailureInformation[] $failureInformation
     * @return \patest\ArrayType\ArrayOfFailureInformation
     */
    public function setFailureInformation(array $failureInformation = array())
    {
        // validation for constraint: array
        if ('' !== ($failureInformationArrayErrorMessage = self::validateFailureInformationForArrayConstraintsFromSetFailureInformation($failureInformation))) {
            throw new \InvalidArgumentException($failureInformationArrayErrorMessage, __LINE__);
        }
        if (is_null($failureInformation) || (is_array($failureInformation) && empty($failureInformation))) {
            unset($this->FailureInformation);
        } else {
            $this->FailureInformation = $failureInformation;
        }
        return $this;
    }
    /**
     * Add item to FailureInformation value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\FailureInformation $item
     * @return \patest\ArrayType\ArrayOfFailureInformation
     */
    public function addToFailureInformation(\patest\StructType\FailureInformation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\FailureInformation) {
            throw new \InvalidArgumentException(sprintf('The FailureInformation property can only contain items of type \patest\StructType\FailureInformation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FailureInformation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\FailureInformation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\FailureInformation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\FailureInformation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\FailureInformation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\FailureInformation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FailureInformation
     */
    public function getAttributeName()
    {
        return 'FailureInformation';
    }
}
